from distutils.core import setup
import os, glob, fnmatch, py2exe

"""Usage:
1. Fill the informations below
2. Go to thorpy's __init__ file and set THORPY_PATH equals to "./" OR simply
    put thorpy's 2exe version (thorpy.org/thorpy2exe.zip) in the same folder as
    this script.
3. Open a console, go to the folder where this script is located, and type:
    python convert2exe.py py2exe
4. That's all. Your executable is normally in 'dist' folder.
"""

main_python_file = "main.py"
project_name = "TheUndefined"
project_url = ""
project_version = "1.0"
project_license = "MIT"
author_name = "Yann Thorimbert"
author_email = "yann.thorimbert@gmail.com"
copyright = "Copyright (c) 2016 Yann Thorimbert"
project_description = "A physically based game"


def add_folder_to_data(dist_folder_name, folder, end=""):
    files = [folder+fn for fn in os.listdir(folder) if fn.endswith(end)]
    data_files.append((dist_folder_name, files))

data_files = []
#add thorpy data
add_folder_to_data("data", "C:/Python34/Lib/site-packages/thorpy/data/")
#for your own data, follow instructions at thorpy.org/tutorials/distribution.html


setup(  windows=[{'script':main_python_file,
                    'copyright': copyright}],
        data_files = data_files,
        name=project_name,
        version = project_version,
        description = project_description,
        url = project_url,
        author = author_name,
        author_email = author_email,
        license = project_license,
        options = {'py2exe':
                    {'includes': [], # name of the modules that py2exe did not automatically detected
                    'excludes' : [], # modules to exclude that py2exe put in
                    'optimize' : 2, # Not necessary,
                    'bundle_files' : 2,
                    'compressed' : True}
                    }
)