import pygame, thorpy, math, random
from pygame.math import Vector2 as V

from physics import CelestialBody, Universe
import parameters, pools, predefined, dialog
from parameters import W,H,MENU_WIDTH,GAME_RECT,GODNESS_SIZE
from parameters import MAX_GODNESS, COSTS, R_SMALL, R_MED, R_BIG
from parameters import M_SMALL, M_MED, M_BIG, C_SMALL, C_MED, C_BIG

# BONUS
#musique
#indiquer le dt au changement
#ombres des planetes sur le sol xD
#choisir vitesse selon longueur d'appui sur le space (fronde)

#it sert a rien
#debris disparaissent pas tous en mm temps
#Main qui envoie?
#couleur speciale pour les asteroides a envoyer (transp)
#encadre avec asteroid et sa fumee (pour previsualiser)
#fumee qui devient noire en vieillissant, et rouge/jaune en naissant ==> feu parfait

#A CONTROLER:
#ordi sandrine
#32 bits
#comparer avec thorpy...

#fond(procedural?), ombres et sons, test.

METADATA_PATH = "./metadata" #create a file for storing data on application

current_y = 300
current_v = (3,0)
current_fire = False
current_explosive = False
last_launch = float("inf")

godness = 50
it = 0
universe = None
scen = None

game = None

events = {}

launcher = None
launcher_mission = None

career_mission = 0
current_mission = 0

def func_before():
    thorpy.parameters.KEY_DELAY = 1
##    launcher.launched.stick_to("screen", "left", "left", False)
    launcher.launched.stick_to("screen", "bottom", "bottom", False)
##    launcher.launched.stick_to(e_sep1, "top", "bottom", False)
##    launcher.launched.move((0,-10))
    launcher.default_func_before()

def func_after():
    launcher.default_func_after()

def mission_choice():
    global launcher_mission
    title = thorpy.make_text("Mission Choice", 15, (255,0,0))
    if current_mission == len(missions.missions)-1:
        dialog.launch_blocking_alert("The End",
        "Congratulations, young dark god. The universe has been almost destroyed.\n\n\n\n\n"+\
        "I've heard the survivors call you ..... The Undefined.")
        ap.fill((255,255,255))
        ap.update()
        go_to_mainmenu()
        return
    buttons = []
    for i, m in enumerate(missions.missions):
        name = m.name
        button = thorpy.make_button(name, load_mission, {"i":i})
        if i > career_mission:
            button.active = False
            button.set_font_color((100,100,100))
        else:
            button.set_main_color((0,255,0))
        buttons.append(button)
    button_box = thorpy.Box.make(buttons)
    if button_box.get_fus_size()[1] < 300:
        button_box.set_size((400, 300))
        for b in buttons:
            b.center(element=button_box, axis=(True,False))
    button_box.refresh_lift()
    box = thorpy.make_ok_box([title,button_box], "Cancel")
    button_box.set_prison()
    launcher_mission = thorpy.get_launcher(box)
    launcher_mission.launch()
##    thorpy.launch(box)


def load_mission(i):
    global universe, current_y, current_v, godness, launcher, launcher_mission, scen, it, current_mission
    current_mission = i
    if launcher is not None:
        launcher.unlaunch("unlaunch objectives")
        launcher = None
    if launcher_mission is not None:
        launcher_mission.unlaunch("unlaunch mission choice")
        launcher_mission = None
    #
    game.e_next_mission.set_main_color(thorpy.style.DEF_COLOR)
    game.e_next_mission.set_font_color((100,100,100))
    game.e_next_mission.active = False
    #
    scen = missions.missions[i].get_copy()
    show_loading()
    #actual loading
    current_explosive = False
    current_fire = False
    last_launch = float("inf")
    it = 0
    predef_asteroids[game.pool_size.value]
    universe = scen.universe
    params = scen.parameters
    current_y = params["current_y"]
    current_v = params["current_v"]
    godness = params["godness"]
    #
    e_objectives = scen.get_e_objectives() #copies
    if e_objectives:
        tmp = thorpy.parameters.FILL_SCREEN_AT_SUBMENUS
        thorpy.parameters.FILL_SCREEN_AT_SUBMENUS = False
        launcher = thorpy.get_launcher(e_objectives, autocenter=False)
        launcher.focus = False
        launcher.func_before = func_before
        launcher.func_after = func_after
        launcher.launch()
        thorpy.parameters.FILL_SCREEN_AT_SUBMENUS = tmp
    #
    game.e_bckgr.unblit_and_reblit()
    universe.draw(ap)
    ap.blit(game.current_asteroid.img, (parameters.LAUNCH_X, current_y))
    update_godness()
##    pygame.display.update(GAME_RECT)
    pygame.display.flip()
    dialog.launch_blocking_alert(scen.name, scen.text)
    game.e_bckgr.unblit_and_reblit()
    if launcher:
        launcher.launched.blit()
    pygame.display.flip()

def get_godness_cost():
    base = COSTS[game.pool_size.value]
    base += current_fire*COSTS["burning"]
    base += current_explosive*COSTS["explosive"]
    return base


def update_godness(draw=True):
    img = game.e_godness.get_image()
    rect = img.get_rect().inflate((-2,-2))
    new_width = godness / MAX_GODNESS * rect.width
    rect_godness = pygame.Rect(rect.x,rect.y,new_width,rect.h)
    godness_cost = get_godness_cost()
    rect_cost = rect_godness.copy()
    rect_cost.width = godness_cost / MAX_GODNESS * GODNESS_SIZE[0]
    rect_cost.right = rect_godness.right
    if godness_cost >= godness:
        color_cost = (50,50,50)
        rect_cost.left = rect_godness.left
    else:
        color_cost = (0,255,0)
    pygame.draw.rect(img, (220,220,220), rect) #empty
    pygame.draw.rect(img, (255,0,0), rect_godness) #avalaible
    pygame.draw.rect(img, color_cost, rect_cost)#needed
    rect_text = game.godness_text.get_rect()
    rect_text.center = rect.center
    img.blit(game.godness_text, rect_text.topleft)
    if draw:
        game.e_godness.blit()
        game.e_godness.update()

def func_num(event):
    if event.key in parameters.K_NUMBERS:
        value = float(pygame.key.name(event.key))
        universe.dt = universe.BASEDT * (1 + (value-1)/9 * parameters.MAX_WARP)

def process_smoke(s,q, generate=True):
    s.kill_old_elements()
    if generate:
        s.generate(V(q))
    s.update_physics()
    s.draw(thorpy.get_screen())

def process_debris(b, q, v, generate=True):
    b.debris.kill_old_elements(GAME_RECT)
    #generate debris:
    if generate:
        angle = int(V(0,1).angle_to(v))
        spread = 15
        bv = math.hypot(v[0],v[1])
        v_range = (int(0.05*bv), int(0.5*bv))
        n = int(2*bv)
        b.debris.generate(V(q),
                         n=n,
                         v_range=v_range,
                         omega_range=(5,25),
                         angle_range=(angle-spread,angle+spread))
    b.debris.update_physics(universe.dt)
    b.debris.draw(thorpy.get_screen())

def make_explosion(body):
    size = get_size_name(body.m)
    smokename = get_size_name(body.m)+"explosion"
    r = parameters.EXPL_R
    for i in range(parameters.N_EXPLOSIONS):
        smoke = smokes[smokename].get_copy()
        q = body.q + (random.randint(-r,r),random.randint(-r,r))
        universe.kill_smokes.append((smoke, tuple(q)))
        smoke.generate(V(q))
        smoke.update_physics()
        smoke.draw(thorpy.get_screen())

#if the explosion is due to a collision:
#if the lightest explodes, then its mass hasn't been modified.
#if the heaviest explodes, then the lightest is already dead anyway
def apply_explosion(body):
    r_explosion = parameters.EXPL_R
    for b in universe.bodies:
        if b is not body:
            if (b.q-body.q).length() < r_explosion:
                print("explosion touch")
                b.m -= 2*body.m
                if b.m < 0:
                    b.m = 0.5*parameters.MIN_MASS

def func_time():
    global last_launch, it, current_y, career_mission
##    print(it)
    keys = pygame.key.get_pressed()
    if keys[pygame.K_UP]:
        current_y -= parameters.LAUNCHER_SHIFT
    if keys[pygame.K_DOWN]:
        current_y += parameters.LAUNCHER_SHIFT
    universe.collide_all()
    universe.update_velocities()
    universe.update_positions()
##    ap.fill((255,255,255))
    thorpy.get_screen().fill((255,255,255), GAME_RECT)
    universe.draw(ap)
    #control objectives completion
    status = scen.update_status(universe)
##    print(status)
    if not False in status:
        if not game.e_next_mission.active:
            game.e_next_mission.set_main_color((0,255,0))
            game.e_next_mission.active = True
            game.e_next_mission.unblit_and_reblit()
            if current_mission == career_mission:
                career_mission += 1
                mdm.data["cm"] = career_mission
                mdm.write_data(METADATA_PATH)
                print("career", career_mission)
    for i,value in enumerate(status):
        checker = launcher.launched.objs[i]
        if value != checker.get_value():
            checker.set_value(value)
            checker.unblit_and_reblit()
    #smoke ##########################################
    smokes_to_kill = []
    for b in universe.bodies:
        if b.smoke:
            process_smoke(b.smoke, b.q)
    for s,q in universe.kill_smokes:
        process_smoke(s,q, generate=False)
        if not s.smokes: #no more smoke to draw
            smokes_to_kill.append((s,q))
    for s,q in smokes_to_kill:
        universe.kill_smokes.remove((s,q))
    #debris #########################################
    debris_to_kill = []
    for b,q,v in universe.must_explode:
        if b.explosive:
            make_explosion(b)
            apply_explosion(b)
        process_debris(b,q,v)
    for b in universe.kill_debris:
        process_debris(b, None, None, generate=False)
        if not b.debris.debris:
            debris_to_kill.append(b)
    for b,q,v in universe.must_explode:
        if b.must_death:
            try:
                universe.bodies.remove(b)
            except:
                pass
    universe.must_explode = set([])
    for b in debris_to_kill:
        universe.kill_debris.remove(b)
    # ###############################################
    ap.blit(game.current_asteroid.img,
            (parameters.LAUNCH_X, current_y-game.current_asteroid.r))
##    launcher.launched.unblit_and_reblit()
    if launcher:
        if launcher.launched.get_fus_rect().right > parameters.MENU_WIDTH:
            launcher.launched.blit()
##        pygame.display.update(launcher.launched.get_fus_rect())
    pygame.display.update(GAME_RECT)
##    pygame.display.flip()
    last_launch += parameters.DRAW_FPS
    it += 1

def func_space():
    global last_launch, godness
    if last_launch > parameters.LAUNCH_DELAY:
        godness_cost = get_godness_cost()
        if godness_cost < godness:
            godness -= godness_cost
            update_godness()
            game.current_asteroid.q[1] = current_y
            universe.bodies.append(get_new_asteroid())
            last_launch = 0
        else:
            print("cannot throw asteroid")

def func_m():
    for b in universe.bodies:
        if b.explosive:
            if b.is_asteroid:
                universe.kill(b, tuple(b.q))
##def func_up():
##    global current_y
##    current_y -= parameters.LAUNCHER_SHIFT
##
##def func_down():
##    global current_y
##    current_y += parameters.LAUNCHER_SHIFT

def get_new_asteroid():
    asteroid = predef_asteroids[game.pool_size.value].copy()
    asteroid.q = V(parameters.LAUNCH_X,current_y)
    asteroid.v = V(current_v)
    asteroid.burning = current_fire
    asteroid.explosive = current_explosive
    smokename = game.pool_size.value+current_explosive*"e"+current_fire*"b"
    asteroid.smoke = smokes[smokename].get_copy()
    asteroid.debris = debris[game.pool_size.value].get_copy()
    if asteroid.burning:
        asteroid.v *= 2.
    asteroid.is_asteroid = True
    return asteroid


def get_size_name(m):
    if m < 0.8:
        return "small"
    elif m < 2:
        return "medium"
    return "big"

def toggle_burning():
    global current_fire
    current_fire=not(current_fire)
    update_godness()
def toggle_explosive():
    global current_explosive
    current_explosive=not(current_explosive)
    update_godness()

def show_loading():
    ap.fill((255,255,255))
    text = thorpy.make_text("Loading ...", 20, (0,0,255))
    text.center()
    text.blit()
    ap.update()

def set_asteroid_size():
    game.current_asteroid = predef_asteroids[game.pool_size.value]
    update_godness()


def play():
    global game
    game = Game()
    thorpy.functions.set_current_menu(game.menu_game) #utile ??
    ap.fill((255,255,255))
    load_mission(career_mission)
##    thorpy.application.SHOW_FPS = True
    thorpy.parameters.KEY_DELAY = 1
    game.menu_game.play()

def launch_credits():
    dialog.launch_blocking_alert("Credits",
    "Author: Yann Thorimbert\nLibraries used: Pygame, ThorPy (www.thorpy.org)",
    transp=False)
    e_main_menu.unblit_and_reblit()

def go_to_mainmenu():
    thorpy.functions.quit_menu_func()
    game.menu_game.set_leave()
    thorpy.functions.set_current_menu(main_menu)
    e_main_menu.unblit_and_reblit()

def launch_esc_menu():
    text = "Are you sure you want to go back\nto main menu?"
    prop1 = ("Yes, I am.",go_to_mainmenu)
    prop2 = ("No, it was a joke.",thorpy.functions.quit_menu_func)
##    thorpy.launch_blocking_choices(text, [prop1, prop2])
##    dialog.launch_blocking_choice("Pause", "blablablablablablablal")
    dialog.launch_blocking_choices(text,[prop1,prop2])

def launch_help():
    text =\
    "Key shortcuts:\n\n"+\
    "   Numbers 1-9: change time warp (be careful with high warps!)\n\n"+\
    "   Space: launch next asteroid (green part of the godness indicates its cost)\n\n"+\
    "   m: explode all current explosive asteroids\n\n"+\
    "   up/down arrow: move the asteroid launch location\n\n"+\
    "   Escape: pause/go to main menu"
    dialog.launch_blocking_alert("Help Menu", "".join([text]))
    game.e_bckgr.unblit_and_reblit()

def restart():
    load_mission(current_mission)


class Game(object):

    def __init__(self):
        godness_text = thorpy.make_text("Godness").get_image()
        e_godness = thorpy.Element()
        from thorpy.painting.painters.classicframe import ClassicFrame
        e_godness.set_painter(ClassicFrame(size=GODNESS_SIZE, pressed=True))
        e_godness.finish()
        gw,gh = godness_text.get_size()
        # ###make sure the font is small enough: ================================
        font_size = thorpy.style.FONT_SIZE
        while GODNESS_SIZE[0] < gw or GODNESS_SIZE[1] < gh:
            font_size -= 1
            godness_text = thorpy.make_text("Godness", font_size).get_image()
            e_godness = thorpy.Element()
            e_godness.set_painter(ClassicFrame(pressed=True))
            e_godness.finish()
            gw,gh = godness_text.get_size()
            e_godness.set_size(GODNESS_SIZE)
        # ### ===================================================================

        # ingame menu ##################################################################
        e_help = thorpy.make_button("Help", launch_help)
        e_restart = thorpy.make_button("Try again", restart)
        e_sep1 = thorpy.Line.make(int(0.9*MENU_WIDTH), "h")
        e_title_size = thorpy.make_text("Asteroid size", font_color=(255,0,0))
        e_small = thorpy.Togglable.make("Small")
        e_medium = thorpy.Togglable.make("Medium")
        e_big = thorpy.Togglable.make("Big")
        e_sep2 = thorpy.Line.make(int(0.9*MENU_WIDTH), "h")
        e_title_property = thorpy.make_text("Asteroid properties", font_color=(255,0,0))
        e_burning = thorpy.Togglable.make("Burning")
        e_explosive = thorpy.Togglable.make("Explosive")
        e_burning.user_func = toggle_burning
        e_explosive.user_func = toggle_explosive
        e_sep3 = thorpy.Line.make((int(0.9*MENU_WIDTH)), "h")
        e_next_mission = thorpy.make_button("Next mission", mission_choice)
##        e_next_mission.change_state(thorpy.constants.STATE_PRESSED)
        e_next_mission.set_font_color((100,100,100))
        e_next_mission.active = False
        #logical exclusion of togglables
        pool_size = pools.TogglablePool({e_small:"small",e_medium:"medium",
                                            e_big:"big"},
                                        first_value=e_small, always_value=True)
        pool_size.function = set_asteroid_size
        buttons = [ e_godness,e_help,e_restart, e_sep1,
                    e_title_size,e_small,e_medium,e_big,e_sep2,
                    e_title_property, e_burning,e_explosive,e_sep3,
                    e_next_mission]

        e_left_menu = thorpy.Box.make(buttons, (MENU_WIDTH, H))
        e_bckgr = thorpy.Background.make(elements=[e_left_menu])
        e_left_menu.stick_to("screen", "left", "left")
        thorpy.store(e_left_menu, y=e_godness.get_fus_size()[1]+30)
        e_godness.stick_to("screen", "top", "top", False)
        e_godness.move((0,10))
        e_next_mission.move((0,50))
        e_help.move((0,-20))
        e_restart.stick_to(e_help,"bottom","top")
        e_restart.move((0,10))
        # reactions ####################################################################
        reac_time = thorpy.ConstantReaction(thorpy.USEREVENT, func_time)
        reac_space = thorpy.ConstantReaction(pygame.KEYDOWN, func_space, {"key":pygame.K_SPACE})
        reac_num = thorpy.Reaction(pygame.KEYDOWN, func_num)
        reac_explo = thorpy.ConstantReaction(pygame.KEYDOWN, func_m, {"key":pygame.K_m})
        reac_esc = thorpy.ConstantReaction(pygame.KEYDOWN, launch_esc_menu, {"key":pygame.K_ESCAPE})
        e_bckgr.add_reactions([reac_time, reac_space, reac_num, reac_esc, reac_explo])
        #
        self.current_asteroid = predef_asteroids[pool_size.value]
        #
        pygame.time.set_timer(thorpy.USEREVENT, 1000//parameters.DRAW_FPS)
        menu_game = thorpy.Menu(e_bckgr, fps=70)
        self.menu_game = menu_game
        self.pool_size = pool_size
        self.e_bckgr = e_bckgr
        self.e_godness = e_godness
        self.godness_text = godness_text
        self.e_next_mission = e_next_mission
##        return menu_game, pool_size, e_bckgr

mdm = thorpy.MetaDataManager()
mdm.read_data(METADATA_PATH)
#try loading screen size and flags (with default values indicated as arguments)
w,h,flags = mdm.get_display_data(METADATA_PATH, w=W, h=H, flags=0)
ap = thorpy.Application((w,h), "The Undefined", flags=flags)
mdm.load_font_data(METADATA_PATH)
career_mission = mdm.data.get("cm",0)
print("Loaded carrer:", career_mission)

thorpy.theme.set_theme("human")

show_loading()

smokes = predefined.build_smokes()
import missions, scenario
scenario.load()
debris = scenario.debris

predef_asteroids = {"small": CelestialBody(R_SMALL, M_SMALL, V(), C_SMALL),
                    "medium": CelestialBody(R_MED, M_MED, V(), C_MED),
                    "big": CelestialBody(R_BIG, M_BIG, V(), C_BIG)}


#main menu #####################################################################

e_title = thorpy.make_text("The Undefined", 25, (255,0,0))

e_play = thorpy.make_button("Play", play)
e_options = thorpy.make_global_display_options(METADATA_PATH,
                                                        "Application options")
e_credits= thorpy.make_button("Credits", launch_credits)
e_quit = thorpy.make_button("Quit", thorpy.functions.quit_menu_func)
elements = [e_title,e_play,e_options,e_credits,e_quit]
e_main_menu = thorpy.Background.make(elements=elements)
thorpy.store(e_main_menu)
e_title.move((0,-50))

main_menu = thorpy.Menu(e_main_menu)
main_menu.play()

ap.quit()