from pygame.math import Vector2 as V
from physics import CelestialBody, Universe
from scenario import Objective, Scenario, AObjective
import parameters
from parameters import V0
import thorpy

##writer = thorpy.Writer()
##def add_newlines(text):
##    width = writer.get_width(text)
##    i = len(text)
##    while width > parameters.MAX_TEXT_WIDTH:
##        new_text = text[:i]
##        i -= 1



# ##################### tuto 1 #############################
sun = CelestialBody(12, 10000., V0-V(100,0), (255,255,0))
earth = CelestialBody(5, 0.1, sun.q-(50,0), (0,0,255))

t1u = Universe(1., 0.2, [sun,earth])
t1u.orbit(earth, sun)

ot1a = Objective(earth, "Blue Planet", parameters.OBJ_DESTROY)
text = "Welcome, young dark god!\n"+\
    "I'm here to teach you the basics of evil and darkness. Well, unfortunately\n"+\
    "we sometimes have to constructively build new orbits or odd things like that.\n"+\
    "But nevermind, today we'll start with a simple, destructive action.\n\n"+\
    "Destroy this old and awful blue planet (we don't need it, there are only\n"+\
    "a few stupid creatures on it. Their name is 'humad' I think, or maybe 'human',\n"+\
    "or something like that. Anyway, use Up and Down key arrows to set your asteroid's\n"+\
    "position, and then press space to throw it.\n\n"+\
    "Once you have successfully completed the objectives, clik on the 'next mission'\n"+\
    "button on the left menu.\n\n" +\
    "As you will experiment, gravity acts on all objects (except debris), as provided\n"+\
    "by the Boss. Use the numbers 0-9 to control time warp. The help button on\n"+\
    "the left summarizes all the keys."
t1 = Scenario(t1u, [ot1a], "Tutorial 1", text)
t1.parameters["godness"] = 10000.


# ##################### tuto 2 #############################
sun = CelestialBody(12, 10, V0, (255,0,0))

t1u = Universe(1., 1., [sun])

ot1a = Objective(sun, "Red Star", parameters.OBJ_DESTROY)
text = "Can you see this small red Star? Destroy it!\n"+\
    "For this, you can make your own asteroids. Big asteroids will decrease your\n"+\
    "godness more than small asteroids. And your godness is important. Without godness,\n"+\
    "you won't be able to continue the mission. Also, you can make your asteroids\n"+\
    "burning (they will go fast!), or explosive (make them explode with m). Explosive\n"+\
    "asteroids cause more damage to the surroundings celestial bodies. And damage is good.\n"+\
    "Most of the time. You can also make burning AND explosive asteroids. In fact,\n"+\
    "you can make BIG, BURNING, EXPLOSIVE asteroids! Mwahahahahahah !\n\n"+\
    "Well, the counterpart is that bigger and features asteroids cost more godness.\n"+\
    "Your godness bar is on the top left. The green part of your godness is there to\n"+\
    "show you how much your godness will decrease if you throw the current chosen asteroid."
t2 = Scenario(t1u, [ot1a], "Tutorial 2", text)

# ##################### mission 1 #############################

m1a = CelestialBody(12, 1000, V(400,300), (0,255,0), V(0,0))
m1b = CelestialBody(5, 10., m1a.q+(200,0), (0,0,255))
m1c = CelestialBody(2, 0.001, m1b.q+(1.5*(m1b.r+2),0), (255,0,0))

m1u = Universe(1., 0.5, [m1a, m1b, m1c])
m1u.orbit(m1b, m1a)
m1u.orbit(m1c, m1b)

o1a = Objective(m1c, "Red Moon", parameters.OBJ_DESTROY)
o1b = Objective(m1b, "Blue Planet", parameters.OBJ_SURVIVE)
o1c = Objective(m1b, "Blue Planet", parameters.OBJ_ORBIT, m1a, "Green Star")
s1 = Scenario(m1u, [o1a,o1b,o1c], "Moon Sniper", "Destroy the Red Moon! But keep the Blue planet alive\n"+\
"and orbiting around the green star.")

# ##################### mission 2 #############################

k1a = CelestialBody(12, 800, V(400,300), (0,255,0), V(0,0))
k1b = CelestialBody(5, 1., k1a.q+(50,0), (0,220,0))
k1c = CelestialBody(5, 1., k1a.q+(100,0), (0,220,0))
k1d = CelestialBody(5, 0.4, k1a.q+(150,0), (0,220,0))

k1u = Universe(1., 0.5, [k1a, k1b, k1c, k1d])
k1u.orbit(k1b, k1a)
k1u.orbit(k1c, k1a)
k1u.orbit(k1d, k1a, sign=-1)

obj = AObjective(k1a, "Green Star")
s2 = Scenario(k1u, [obj], "Green System", "Orbit any asteroid around the Green Star. Yep.")


##
# ##################### mission 3 #############################
m3a = CelestialBody(8, 100, V(400,300), (0,255,0), V(0,0.55))
m3b = CelestialBody(8, 100, m3a.q-(70,0), (0,255,255), V(0,-0.55))

m3u = Universe(1., 1., [m3a, m3b])
o2 = Objective(m3b, "Turquoise Star", parameters.OBJ_DESTROY)
s3 = Scenario(m3u, [o2], "Twin Stars", "Destroy the Turquoise star. Use the aftermaths of resonance.")
s3.parameters["godness"] = 200

# ##################### mission 4 #############################

m1a = CelestialBody(12, 1000, V(500,300), (0,255,0), V(0,0))
m1b = CelestialBody(5, 10., m1a.q+(210,0), (0,0,255))
m1c = CelestialBody(2, 0.001, m1b.q+(1.5*(m1b.r+2),0), (255,0,0))
m1d = CelestialBody(7, 10, m1a.q-(100,0), (255,0,0))

m1u = Universe(1., 0.5, [m1a, m1b, m1c, m1d])
m1u.orbit(m1b, m1a)
m1u.orbit(m1c, m1b)
m1u.orbit(m1d, m1a)

o1a = Objective(m1c, "Red Moon", parameters.OBJ_DEORBIT, m1b, "Blue Planet")
s4 = Scenario(m1u, [o1a], "Moon Push", "Deorbit the Red Moon from the Blue Planet. They don't need it.\n")


# ##################### mission 5 #############################
m2a = CelestialBody(12, 10000, V(400,300), (0,255,0), V(0,0))
m2b = CelestialBody(5, 20., m2a.q+(100,0), (0,0,255))
m2c = CelestialBody(5, 20., m2a.q-(120,0), (255,0,0))

m2u = Universe(1., 0.1, [m2a, m2b, m2c])
m2u.orbit(m2b, m2a)
m2u.orbit(m2c, m2b)

obj = Objective(m2c, "Red Planet", parameters.OBJ_DESTROY)
obj2 = Objective(m2b, "Blue Planet", parameters.OBJ_SURVIVE)
s5 = Scenario(m2u, [obj, obj2], "Dangerous Orbits", "The Boss said 'I want more simmetry'.\nThus, let the Red Planet disappear.\n"+\
"And the Blue one live.")

# ##################### mission 6 #############################

m1a = CelestialBody(12, 1000, V(500,300), (0,255,0), V(0,0))
m1b = CelestialBody(5, 10., m1a.q+(210,0), (0,0,255))
m1c = CelestialBody(2, 0.001, m1b.q+(1.5*(m1b.r+2),0), (255,0,0))
m1d = CelestialBody(7, 10, m1a.q-(100,0), (255,0,0))
e = CelestialBody(5, 8, m1a.q+(50,0), (255,255,0))
f = CelestialBody(7, 10, V(600,50), (255,0,255))

m1u = Universe(1., 0.5, [m1a, m1b, m1c, m1d,e,f])
m1u.orbit(m1b, m1a)
m1u.orbit(m1c, m1b)
m1u.orbit(m1d, m1a)
m1u.orbit(e, m1a)
m1u.orbit(f, m1a, spec_energy=-2)

o1 = Objective(e, "Yellow Planet", parameters.OBJ_DESTROY)
o2 = Objective(f, "Purple Planet", parameters.OBJ_SURVIVE)
o3 = Objective(m1d, "Red Planet", parameters.OBJ_SURVIVE)
o4 = Objective(m1b, "Blue Planet", parameters.OBJ_SURVIVE)
o5 = Objective(m1c, "Red Moon", parameters.OBJ_SURVIVE)
s6 = Scenario(m1u, [o1,o2,o3,o4,o5], "Planet Sniper", "Destroy the Yellow Planet. Let all the others alive.")


# ##################### mission 7 #############################

m1a = CelestialBody(12, 10000, V(500,300), (0,0,0), V(0,0))
m1b = CelestialBody(5, 10., m1a.q+(210,0), (0,0,255))
m1c = CelestialBody(2, 0.001, m1b.q+(1.5*(m1b.r+2),0), (255,0,0))
m1d = CelestialBody(7, 10, m1a.q-(100,0), (255,0,0))
e = CelestialBody(5, 8, m1a.q+(50,0), (255,0,0))
f = CelestialBody(7, 10, V(550,50), (255,0,0))
g = CelestialBody(7, 5, V(200,300), (255,0,0))
h = CelestialBody(3, 0.001, g.q+(1.5*(g.r+2),0), (255,0,0))

m1u = Universe(1., 0.5, [m1a, m1b, m1c, m1d,e,f,g,h])
m1u.orbit(m1b, m1a)
m1u.orbit(m1c, m1b)
m1u.orbit(m1d, m1a)
m1u.orbit(e, m1a)
m1u.orbit(f, m1a, spec_energy=-2)
m1u.orbit(g, m1a)
m1u.orbit(h,g)

o4 = Objective(m1b, "Blue Planet", parameters.OBJ_SURVIVE)
o1 = Objective(e, "Red Planet", parameters.OBJ_DESTROY)
o2 = Objective(f, "Red Planet", parameters.OBJ_DESTROY)
o3 = Objective(m1d, "Red Planet", parameters.OBJ_DESTROY)
o5 = Objective(m1c, "Red Moon", parameters.OBJ_DESTROY)
o6 = Objective(g, "Red Planet", parameters.OBJ_DESTROY)
o7 = Objective(h, "Red Moon", parameters.OBJ_DESTROY)
s7 = Scenario(m1u, [o1,o2,o3,o4,o5,o6,o7], "Final Cataclysm",
"Finally, we get there.\n"+\
"I wanted to bring a negative-mass asteroid, but I've lost it. So, you will have to deal\n"+\
"with the usual weapons.\n\n"+\
"The objective now is to eradicate these horrible red bodies orbiting\n"+\
"around the black star. However, the Boss's summer house is located on the blue planet.\nDO NOT destroy this planet!")

missions = [t1, t2, s1, s2, s6, s5, s3, s4, s7]