import thorpy

class TogglablePool(object):

    def __init__(self, elements, first_value=None, always_value=False):
        for e in elements:
            reac = thorpy.ConstantReaction(thorpy.THORPY_EVENT, self.refresh,
                        event_args={"id":thorpy.constants.EVENT_TOGGLE,
                                    "el":e},
                        params={"selected":e})
            e.add_reaction(reac)
        self.elements = elements
        self.value = None
        if first_value:
            self.value = elements[first_value]
##            first_value._press()
            #
            first_value.change_state(thorpy.constants.STATE_PRESSED)
            first_value._hovered = True
            sn = first_value.current_state_key
            if sn in first_value._states_hover:
                first_value.current_state.fusionner.img = first_value._hover_imgs[sn]
                first_value._updates[sn].center = first_value.get_fus_center(sn)
            first_value._count += 1
            first_value.toggled = True
        self.always_value = always_value

    def refresh(self, selected):
        for e in self.elements:
            if e is not selected:
                e.active = True
                e._force_unpress()
                e._hovered = False
                e._unhover()
        if self.always_value:
            selected.active = False
        self.value = self.elements[selected]
        if self.function: #a enlever pour thorpy
            self.function()
